-- Change this to the destination computer's ip address
ipaddress = "192.168.100.1"


dofile "wlanconfig.lua"

System.usbDiskModeActivate()

-- create a new Color object
white = Color.new(255, 255, 255)
green = Color.new(0, 255, 0)
black = Color.new(0,0,0 )


console = Image.createEmpty(160, 72)
console:clear(black)
tempImg = Image.createEmpty(160, 72)
tempImg:clear(black)


leftTriggerImg = Image.load("lefttrigger.png")
leftTriggerDownImg = Image.load("lefttrigger-down.png")
rightTriggerImg = Image.load("righttrigger.png")
rightTriggerDownImg = Image.load("righttrigger-down.png")

analogImg = Image.load("analog.png")
analog1Img = Image.load("analog-1.png")
analog2Img = Image.load("analog-2.png")
analog3Img = Image.load("analog-3.png")
analog4Img = Image.load("analog-4.png")
analog5Img = Image.load("analog-5.png")
analog6Img = Image.load("analog-6.png")
analog7Img = Image.load("analog-7.png")
analog8Img = Image.load("analog-8.png")
analog9Img = Image.load("analog-9.png")
analog10Img = Image.load("analog-10.png")
analog11Img = Image.load("analog-11.png")
analog12Img = Image.load("analog-12.png")
lastAnalogImg = analog1Img


controlImg = Image.load("control.png")
controlUImg = Image.load("control-u.png")
controlULImg = Image.load("control-lu.png")
controlLImg = Image.load("control-l.png")
controlDLImg = Image.load("control-ld.png")
controlDImg = Image.load("control-d.png")
controlDRImg = Image.load("control-dr.png")
controlRImg = Image.load("control-r.png")
controlURImg = Image.load("control-ru.png")





texty = 0
textx = 0

dx = 0
dy = 0
ax = 0
ay = 0



function cprint(text)
  for i = 1, string.len(text) do
    char = string.sub(text, i, i)
    if char == "\n" then
      if texty < 60 then
        texty = texty + 8
      else
  tempImg:blit(0, 0, console)
        console:clear(black)
        console:blit(0, -8, tempImg)
      end


      textx = 0
    elseif char ~= "\r" then
      console:print(textx, texty, char, white)
      textx = textx + 8
    end
  end
  --screen:blit(0, 0, console)
  --screen.waitVblankStart()
  --screen.flip()
end



--select network
chooseNetwork()

--clear screen

screen:clear(black)

socket, error = Socket.connect(ipaddress, 2006)
cprint ("Connecting....")
while not socket:isConnected() do 
  pad = Controls.read()
  if pad:start() then
    socket:close()
    Wlan.term()
    break
  end  
   System.sleep(100)
  screen.waitVblankStart()
end
cprint("\nConnected!\n" .. error)



buttonStates = {0,0,0,0,0,0,0,0,0,0,0,0}
buttonText = {"M","m","d","a","Octave -","Octave +",0,0,0,0,0,0}


-- wait forevever
while true do
screen:clear(black)
  pad = Controls.read()

  if pad:up() and buttonStates[1] == 0 then
    socket:send("u1")
    buttonStates[1] = 1
  elseif not pad:up() and buttonStates[1] == 1 then
    socket:send("u0")
    buttonStates[1] = 0

  end
  if pad:down() and buttonStates[2] == 0 then
    socket:send("d1")
    buttonStates[2] = 1
  elseif not pad:down() and buttonStates[2] == 1 then
    socket:send("d0")
    buttonStates[2] = 0
  end

  if pad:left() and buttonStates[3] == 0 then
    socket:send("l1")
    buttonStates[3] = 1
  elseif not pad:left() and buttonStates[3] == 1 then
    socket:send("l0")
    buttonStates[3] = 0
  end

  if pad:right() and buttonStates[4] == 0 then
    socket:send("r1")
    buttonStates[4] = 1
  elseif not pad:right() and buttonStates[4] == 1 then
    socket:send("r0")
    buttonStates[4] = 0
  end

  if pad:r() and buttonStates[5] == 0 then
    socket:send("i1")
    buttonStates[5] = 1
  elseif not pad:r() and buttonStates[5] == 1 then
    socket:send("i0")
    buttonStates[5] = 0
  end

  if pad:l() and buttonStates[6] == 0 then
    socket:send("e1")
    buttonStates[6] = 1
  elseif not pad:l() and buttonStates[6] == 1 then
    socket:send("e0")
    buttonStates[6] = 0
  end

  if pad:triangle() and buttonStates[7] == 0 then
    socket:send("t1")
    buttonStates[7] = 1
  elseif not pad:triangle() and buttonStates[7] == 1 then
    socket:send("t0")
    buttonStates[7] = 0
  end

  if pad:circle() and buttonStates[8] == 0 then
    socket:send("o1")
    buttonStates[8] = 1
  elseif not pad:circle() and buttonStates[8] == 1 then
    socket:send("o0")
    buttonStates[8] = 0
  end


  if pad:cross() and buttonStates[9] == 0 then
    socket:send("x1")
    buttonStates[9] = 1
  elseif not pad:cross() and buttonStates[9] == 1 then
    socket:send("x0")
    buttonStates[9] = 0
  end

  if pad:square() and buttonStates[10] == 0 then
    socket:send("s1")
    buttonStates[10] = 1
  elseif not pad:square() and buttonStates[10] == 1 then
    socket:send("s0")
    buttonStates[10] = 0
  end

  if pad:note() and buttonStates[11] == 0 then
    socket:send("n1")
    buttonStates[11] = 1
  elseif not pad:note() and buttonStates[11] == 1 then
    socket:send("n0")
    buttonStates[11] = 0
  end

  if pad:select() and buttonStates[12] == 0 then
    socket:send("q1")
    buttonStates[12] = 1
  elseif not pad:select() and buttonStates[12] == 1 then
    socket:send("q0")
    buttonStates[12] = 0
  end

  if pad:start() then
    socket:close()
    Wlan.term()
    break
  end


  if not socket:isConnected() then
    cprint("Disconected!!!")    
  end

  ax = pad:analogX()
  ay = pad:analogY()

  socket:send("a")
  socket:send(ax+500)
  socket:send(ay+500)
  
  rcv = socket:recv()
 

    
    
--Graphical code below--
  if buttonStates[1] == 0 and buttonStates[2] == 0 and buttonStates[3] == 0 and buttonStates[4] == 0 then
    screen:blit(0, 70, controlImg)
  elseif buttonStates[1] == 1 and buttonStates[2] == 0 and buttonStates[3] == 0 and buttonStates[4] == 0 then
    screen:blit(0, 70, controlUImg)
  elseif buttonStates[1] == 1 and buttonStates[2] == 0 and buttonStates[3] == 1 and buttonStates[4] == 0 then
    screen:blit(0, 70, controlULImg)
  elseif buttonStates[1] == 1 and buttonStates[2] == 0 and buttonStates[3] == 0 and buttonStates[4] == 1 then
    screen:blit(0, 70, controlURImg)
  elseif buttonStates[1] == 0 and buttonStates[2] == 1 and buttonStates[3] == 0 and buttonStates[4] == 0 then
    screen:blit(0, 70, controlDImg)
  elseif buttonStates[1] == 0 and buttonStates[2] == 1 and buttonStates[3] == 1 and buttonStates[4] == 0 then
    screen:blit(0, 70, controlDLImg)
  elseif buttonStates[1] == 0 and buttonStates[2] == 1 and buttonStates[3] == 0 and buttonStates[4] == 1 then
    screen:blit(0, 70, controlDRImg)
  elseif buttonStates[1] == 0 and buttonStates[2] == 0 and buttonStates[3] == 1 and buttonStates[4] == 0 then
    screen:blit(0, 70, controlLImg)
  elseif buttonStates[1] == 0 and buttonStates[2] == 0 and buttonStates[3] == 0 and buttonStates[4] == 1 then
    screen:blit(0, 70, controlRImg)
  end


  aDistance = math.sqrt(ax*ax + ay*ay)
  aAngle = math.deg(math.atan2(-ay, ax))  
  if startingPosition == 1 and aDistance > 100 then
    startingPosition = 0
  end  

  if aAngle >0 and aAngle < 30 and aDistance > 100 then
    screen:blit(154, 0, analog1Img)
    lastAnalogImg = analog1Img
  elseif aAngle >30 and aAngle < 60 and aDistance > 100 then
    screen:blit(154, 0, analog2Img)
    lastAnalogImg = analog2Img
  elseif aAngle >60 and aAngle < 90 and aDistance > 100 then
    screen:blit(154, 0, analog3Img)
    lastAnalogImg = analog3Img
  elseif aAngle >90 and aAngle < 120 and aDistance > 100 then
    screen:blit(154, 0, analog4Img)
    lastAnalogImg = analog4Img
  elseif aAngle >120 and aAngle < 150 and aDistance > 100 then
    screen:blit(154, 0, analog5Img)
    lastAnalogImg = analog5Img
  elseif aAngle >150 and aAngle < 180 and aDistance > 100 then
    screen:blit(154, 0, analog6Img)
    lastAnalogImg = analog6Img
  elseif aAngle <0 and aAngle > -30 and aDistance > 100 then
    screen:blit(154, 0, analog12Img)
    lastAnalogImg = analog12Img
  elseif aAngle <-30 and aAngle > -60 and aDistance > 100 then
    screen:blit(154, 0, analog11Img)
    lastAnalogImg = analog11Img
  elseif aAngle < -60 and aAngle > -90 and aDistance > 100 then
    screen:blit(154, 0, analog10Img)
    lastAnalogImg = analog10Img
  elseif aAngle < -90 and aAngle > -120 and aDistance > 100 then
    screen:blit(154, 0, analog9Img)
    lastAnalogImg = analog9Img
  elseif aAngle < -120 and aAngle > -150 and aDistance > 100 then
    screen:blit(154, 0, analog8Img)
    lastAnalogImg = analog8Img
  elseif aAngle < -150 and aAngle > -180 and aDistance > 100 then
    screen:blit(154, 0, analog7Img)
    lastAnalogImg = analog7Img
  else
    screen:blit(154, 0, lastAnalogImg)
  end



  if buttonStates[6] == 0 then
    screen:blit(0, 0, leftTriggerImg)
  elseif buttonStates[6] == 1 then
    screen:blit(0, 0, leftTriggerDownImg)
  end

  if buttonStates[5]==0 then
    screen:blit(326, 0, rightTriggerImg)
  elseif buttonStates[5] == 1 then
    screen:blit(326, 0, rightTriggerDownImg)
  end


  if buttonStates[7] == 1 then
    screen:drawLine(326, 80, 480, 80, white)
  end
  if buttonStates[8] == 1 then
    screen:drawLine(326, 120, 480, 100, white)
  end
  if buttonStates[9] == 1 then
    screen:drawLine(326, 160, 480, 120, white)
  end
  if buttonStates[10] == 1 then
    screen:drawLine(326, 200, 480, 140, white)
  end


--Draw Text--
  



  screen:blit(160, 200, console)

  screen.flip()
  screen.waitVblankStart()
  System.powerTick()
  
  
end